// $Id:

(function ($) {
var gd_infinite_scroll_was_initialised = false;
Drupal.behaviors.gd_infinite_scroll = {
  attach:function() {
    // Make sure that autopager plugin is loaded
    if($.autopager) {
      if(!gd_infinite_scroll_was_initialised) {
        gd_infinite_scroll_was_initialised = true;
        // There should not be multiple Infinite Scroll Views on the same page
        if(Drupal.settings.gd_infinite_scroll.length == 1) { 
          var settings = Drupal.settings.gd_infinite_scroll[0];
    
          var content_selector = settings.content_selector;
          var items_selector   = settings.content_selector + ' ' + settings.items_selector;
          var pager_selector   = settings.pager_selector;
          var next_selector    = settings.next_selector;
          var img_location     = settings.content_selector;
          var img_path         = settings.img_path;
          var img              = '<div id="gd_infinite_scroll-ajax-loader"><img src="' + img_path + '" alt="loading..."/></div>';
          $(pager_selector).hide();
          var handle = $.autopager({
            appendTo: content_selector,
            content: items_selector,
            link: next_selector,
            page: 0,
            start: function() {
              $(img_location).after(img);
            },
            load: function() {
              $('div#gd_infinite_scroll-ajax-loader').remove();
              Drupal.attachBehaviors(this);
            }
          });
  
          // Trigger autoload if content height is less than doc height already
          var prev_content_height = $(content_selector).height();
          do {
            var last = $(items_selector).filter(':last');
            if(last.offset().top + last.height() < $(document).scrollTop() + $(window).height()) {
              last = $(items_selector).filter(':last');
              handle.autopager('load');
            }
            else {
              break;
            }
          }
          while ($(content_selector).height() > prev_content_height);
        }
        else if(Drupal.settings.gd_infinite_scroll.length > 1) {
          alert(Drupal.t('GD Infinite Scroll module can\'t handle more than one infinite view in the same page.'));
        }
      }
    }
    else {
      alert(Drupal.t('Autopager jquery plugin in not loaded.'));
    }
  }
}

})(jQuery);
